import { observable as rxjs, URI } from 'fp-ts-rxjs/lib/Observable';
import { MonadObservable1 } from '@devexperts/utils/dist/typeclasses/monad-observable/monad-observable';
import { Observable } from 'rxjs';
export declare const instanceObservable: typeof rxjs & MonadObservable1<URI>;
export declare const observable: {
    zero: () => Observable<never>;
    hold: <A>(source: Observable<A>) => Observable<A>;
    chain: <A_1, B>(f: (a: A_1) => Observable<B>) => (ma: Observable<A_1>) => Observable<B>;
    chainFirst: <A_2, B_1>(f: (a: A_2) => Observable<B_1>) => (ma: Observable<A_2>) => Observable<A_2>;
    flatten: <A_3>(mma: Observable<Observable<A_3>>) => Observable<A_3>;
    ap: <A_4>(fa: Observable<A_4>) => <B_2>(fab: Observable<(a: A_4) => B_2>) => Observable<B_2>;
    apFirst: <B_3>(fb: Observable<B_3>) => <A_5>(fa: Observable<A_5>) => Observable<A_5>;
    apSecond: <B_4>(fb: Observable<B_4>) => <A_6>(fa: Observable<A_6>) => Observable<B_4>;
    map: <A_7, B_5>(f: (a: A_7) => B_5) => (fa: Observable<A_7>) => Observable<B_5>;
    alt: <A_8>(that: () => Observable<A_8>) => (fa: Observable<A_8>) => Observable<A_8>;
    filter: {
        <A_9, B_6 extends A_9>(refinement: import("fp-ts/lib/function").Refinement<A_9, B_6>): (fa: Observable<A_9>) => Observable<B_6>;
        <A_10>(predicate: import("fp-ts/lib/function").Predicate<A_10>): (fa: Observable<A_10>) => Observable<A_10>;
    };
    filterMap: <A_11, B_7>(f: (a: A_11) => import("fp-ts/lib/Option").Option<B_7>) => (fa: Observable<A_11>) => Observable<B_7>;
    partition: {
        <A_12, B_8 extends A_12>(refinement: import("fp-ts/lib/function").Refinement<A_12, B_8>): (fa: Observable<A_12>) => import("fp-ts/lib/Compactable").Separated<Observable<A_12>, Observable<B_8>>;
        <A_13>(predicate: import("fp-ts/lib/function").Predicate<A_13>): (fa: Observable<A_13>) => import("fp-ts/lib/Compactable").Separated<Observable<A_13>, Observable<A_13>>;
    };
    partitionMap: <A_14, B_9, C>(f: (a: A_14) => import("fp-ts/lib/Either").Either<B_9, C>) => (fa: Observable<A_14>) => import("fp-ts/lib/Compactable").Separated<Observable<B_9>, Observable<C>>;
    compact: <A_15>(fa: Observable<import("fp-ts/lib/Option").Option<A_15>>) => Observable<A_15>;
    separate: <A_16, B_10>(fa: Observable<import("fp-ts/lib/Either").Either<A_16, B_10>>) => import("fp-ts/lib/Compactable").Separated<Observable<A_16>, Observable<B_10>>;
    of: <A_17>(a: A_17) => Observable<A_17>;
    URI: "Observable";
    fromEvent: import("@devexperts/utils/dist/typeclasses/monad-observable/monad-observable").FromEvent1<"Observable">;
    fromObservable: <A_18>(observable: import("@devexperts/utils/dist/typeclasses/monad-observable/monad-observable").Observable<A_18>) => Observable<A_18>;
    createAdapter: <A_19>() => [(a: A_19) => void, Observable<A_19>];
    subscribe: <A_20>(fa: Observable<A_20>, observer: import("@devexperts/utils/dist/typeclasses/monad-observable/monad-observable").Observer<A_20>) => import("@devexperts/utils/dist/typeclasses/monad-observable/monad-observable").Subscription;
    fromTask: <A_21>(fa: import("fp-ts/lib/Task").Task<A_21>) => Observable<A_21>;
    fromIO: <A_22>(fa: import("fp-ts/lib/IO").IO<A_22>) => Observable<A_22>;
};
